# Usage of TCP ports

The list of TCP ports used in SOCtools, as available from the outside:

## Web interfaces

| port  | description |
| ----: | ----------- |
|  5601 | Kibana |
|  6443 | MISP |
|  8888 | haproxy-stats (login: `haproxy`, password is in `secrets/passwords/haproxy`)
|  9000 | TheHive |
|  9001 | Cortex |
|  9443 | NiFi web GUI |
| 12443 | Keycloak |

TODO others?
TODO open to anyone / local only?

## Data ingestion

The following port ranges are opened by haproxy to allow receiving data from external systems. These ports are forwarded to NiFi nodes. So, a processor in NiFi can listen on these ports and receive data from other systems.

TODO

NOTES-1: According to haproxy.cfg, the followng ports are forwarded to NiFi:
- 7750-7760 (tcp)
- 7771 (tcp)
- 5000-5020 (http)
- 6000-6020 (tcp)
In fact, I can connect (using `nc`) to these ports 7750, 5000-5099, 6000-6099 (i.e. not 7751-7760, 7771; on the other hand, the 50??,60?? ranges are wider, I don't know where they are pointed to).

NOTES-2: haproxy container is listening on following ports:
- 0.0.0.0:443->443/tcp
- 0.0.0.0:5000-5099->5000-5099/tcp
- 0.0.0.0:6000-6099->6000-6099/tcp
- 0.0.0.0:7750->7750/tcp
- 0.0.0.0:8443->8443/tcp
- 0.0.0.0:8888->8888/tcp
- 0.0.0.0:9000-9001->9000-9001/tcp
- 0.0.0.0:9200->9200/tcp
- 0.0.0.0:9443->9443/tcp

NOTES-3: From haproxy.cfg, following ports should go through haproxy:
| port  | description |
| ----: | ----------- |
|  8888 | haproxy-stats |
|  9000 | TheHive |
|  9001 | Cortex |
|  9200 | ODFEES |
|  9443 | NiFi web GUI |
| 12443 | Keycloak | - incorectly configured frontend on port 10443

NOTES-4: There are a number of ports that are just made visible using EXPOSE, but are not actually published, i.e. they cannot be reached directly outside of docker, such as:

| container(s)  | port(s) |
| ----: | ----------- |
| soctools-misp  | 80, 443, 6379, 6666, 50000 |
| soctools-cortex | 9000 |
| soctools-thehive  | 9001 |
| soctools-cassandra  | 7000, 9042 |
| soctools-odfe-1/2  | 9200, 9300 |
| soctools-nifi-1/2/3 | 8000, 8080, 8443, 10000 |
| soctools-zookeeper | 2181, 2888, 3888 |
| soctools-keycloak | 8080 |
| soctools-mysql | 3306 |


Ports already used or reserved for ingesting specific data into the system via NiFi:

| port  | description |
| ----: | ----------- |

TODO (e.g. port(s) used for preconfigured ListenBeats data)
